#ifndef USERID_LIST_H
#define USERID_LIST_H

#include "protection.h"

extern player_t players[32];
#define _LISTNAME players
#define _USERIDNAME UserID

//Mark disconnected players with these flags!
#define SF_PLAYER_DISCONNECTED1	(1<<27)
#define SF_PLAYER_DISCONNECTED2 (1<<29)

//No loops used so that Borland C++ can use these as inline functions

#define ADDLIST_CHECK_FIRST(nmo)     if (_LISTNAME[nmo]._USERIDNAME==-1) {_LISTNAME[nmo]._USERIDNAME=userid; return nmo;}
#define ADDLIST_CHECK_NEXT(nmo) else if (_LISTNAME[nmo]._USERIDNAME==-1) {_LISTNAME[nmo]._USERIDNAME=userid; return nmo;}

//Returns new listid!
inline int AddToUserList(int userid)
{
	ADDLIST_CHECK_FIRST(0)
	ADDLIST_CHECK_NEXT(1)
	ADDLIST_CHECK_NEXT(2)
	ADDLIST_CHECK_NEXT(3)
	ADDLIST_CHECK_NEXT(4)
	ADDLIST_CHECK_NEXT(5)
	ADDLIST_CHECK_NEXT(6)
	ADDLIST_CHECK_NEXT(7)
	ADDLIST_CHECK_NEXT(8)
	ADDLIST_CHECK_NEXT(9)
	ADDLIST_CHECK_NEXT(10)
	ADDLIST_CHECK_NEXT(11)
	ADDLIST_CHECK_NEXT(12)
	ADDLIST_CHECK_NEXT(13)
	ADDLIST_CHECK_NEXT(14)
	ADDLIST_CHECK_NEXT(15)
	ADDLIST_CHECK_NEXT(16)
	ADDLIST_CHECK_NEXT(17)
	ADDLIST_CHECK_NEXT(18)
	ADDLIST_CHECK_NEXT(19)
	ADDLIST_CHECK_NEXT(20)
	ADDLIST_CHECK_NEXT(21)
	ADDLIST_CHECK_NEXT(22)
	ADDLIST_CHECK_NEXT(23)
	ADDLIST_CHECK_NEXT(24)
	ADDLIST_CHECK_NEXT(25)
	ADDLIST_CHECK_NEXT(26)
	ADDLIST_CHECK_NEXT(27)
	ADDLIST_CHECK_NEXT(28)
	ADDLIST_CHECK_NEXT(29)
	ADDLIST_CHECK_NEXT(30)
	ADDLIST_CHECK_NEXT(31)
	return -1;
}

inline int GetUserIDByListID(int listid)
{
	if (listid<0 || listid>31) return -1;
	return _LISTNAME[listid]._USERIDNAME;
}

#define GETLIST_CHECK_FIRST(nmo)     if (_LISTNAME[nmo]._USERIDNAME==userid) return nmo
#define GETLIST_CHECK_NEXT(nmo) else if (_LISTNAME[nmo]._USERIDNAME==userid) return nmo

inline int GetListIDByUserID(int userid)
{
	GETLIST_CHECK_FIRST(0);
	GETLIST_CHECK_NEXT(1);
	GETLIST_CHECK_NEXT(2);
	GETLIST_CHECK_NEXT(3);
	GETLIST_CHECK_NEXT(4);
	GETLIST_CHECK_NEXT(5);
	GETLIST_CHECK_NEXT(6);
	GETLIST_CHECK_NEXT(7);
	GETLIST_CHECK_NEXT(8);
	GETLIST_CHECK_NEXT(9);
	GETLIST_CHECK_NEXT(10);
	GETLIST_CHECK_NEXT(11);
	GETLIST_CHECK_NEXT(12);
	GETLIST_CHECK_NEXT(13);
	GETLIST_CHECK_NEXT(14);
	GETLIST_CHECK_NEXT(15);
	GETLIST_CHECK_NEXT(16);
	GETLIST_CHECK_NEXT(17);
	GETLIST_CHECK_NEXT(18);
	GETLIST_CHECK_NEXT(19);
	GETLIST_CHECK_NEXT(20);
	GETLIST_CHECK_NEXT(21);
	GETLIST_CHECK_NEXT(22);
	GETLIST_CHECK_NEXT(23);
	GETLIST_CHECK_NEXT(24);
	GETLIST_CHECK_NEXT(25);
	GETLIST_CHECK_NEXT(26);
	GETLIST_CHECK_NEXT(27);
	GETLIST_CHECK_NEXT(28);
	GETLIST_CHECK_NEXT(29);
	GETLIST_CHECK_NEXT(30);
	GETLIST_CHECK_NEXT(31);
		
	return -1;
}

#endif

